Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering/3.3/OrienteeringProblemdata.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering/3.3/OrienteeringProblemdata.cs	(revision 17525)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering/3.3/OrienteeringProblemdata.cs	(revision 17525)
@@ -0,0 +1,105 @@
+﻿using System;
+using System.Linq;
+using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Encodings.IntegerVectorEncoding;
+using HeuristicLab.Problems.Instances.Types;
+using HeuristicLab.Problems.TravelingSalesman;
+
+namespace HeuristicLab.Problems.Orienteering {
+  [StorableType("dd2d0ecc-372e-46f1-846f-fb4ca2afa124")]
+  public interface IOrienteeringProblemData : INamedItem {
+    ITSPData RoutingData { get; }
+    int StartingPoint { get; }
+    int TerminalPoint { get; }
+    double MaximumTravelCosts { get; }
+    double PointVisitingCosts { get; }
+
+    double GetScore(int city);
+    OrienteeringSolution GetSolution(IntegerVector route, double quality, double score, double travelCosts);
+    OPData Export();
+  }
+
+  [Item("Orienteering Problem Data", "Represents the main data for an orienteering problem.")]
+  [StorableType("d7d2d61a-7d51-4254-ab68-375942106058")]
+  public class OrienteeringProblemData : NamedItem, IOrienteeringProblemData {
+    [Storable] public ITSPData RoutingData { get; protected set; }
+    [Storable] public int StartingPoint { get; protected set; }
+    [Storable] public int TerminalPoint { get; protected set; }
+    [Storable] public DoubleArray Scores { get; protected set; }
+    [Storable] public double MaximumTravelCosts { get; protected set; }
+    [Storable] public double PointVisitingCosts { get; protected set; }
+
+    [StorableConstructor]
+    protected OrienteeringProblemData(StorableConstructorFlag _) : base(_) { }
+    protected OrienteeringProblemData(OrienteeringProblemData original, Cloner cloner) : base(original, cloner) {
+      RoutingData = original.RoutingData;
+      StartingPoint = original.StartingPoint;
+      TerminalPoint = original.TerminalPoint;
+      Scores = original.Scores;
+      MaximumTravelCosts = original.MaximumTravelCosts;
+      PointVisitingCosts = original.PointVisitingCosts;
+    }
+    public OrienteeringProblemData() {
+      RoutingData = new EuclideanTSPData("HL OP Default", defaultCoordinates);
+      Name = RoutingData.Name;
+      StartingPoint = 0;
+      TerminalPoint = 20;
+      Scores = new DoubleArray(Enumerable.Repeat(1.0, RoutingData.Cities).ToArray(), @readonly: true);
+      MaximumTravelCosts = 30;
+      PointVisitingCosts = 0;
+    }
+    public OrienteeringProblemData(ITSPData tspData, int startingPoint, int terminalPoint, double[] scores, double maxDist, double pointVisitCosts)
+      : this(tspData, startingPoint, terminalPoint, new DoubleArray(scores, @readonly: true), maxDist, pointVisitCosts) { }
+    public OrienteeringProblemData(ITSPData tspData, int startingPoint, int terminalPoint, DoubleArray scores, double maxDist, double pointVisitCosts)
+      : base(tspData.Name, tspData.Description) {
+      if (tspData.Cities != scores.Length) throw new ArgumentException("Unequal number of cities and scores.");
+      if (startingPoint < 0 || startingPoint >= tspData.Cities) throw new ArgumentException("Starting point is not in the range of cities.", "startingPoint");
+      if (terminalPoint < 0 || terminalPoint >= tspData.Cities) throw new ArgumentException("Starting point is not in the range of cities.", "startingPoint");
+      RoutingData = tspData;
+      StartingPoint = startingPoint;
+      TerminalPoint = terminalPoint;
+      Scores = scores.AsReadOnly();
+      MaximumTravelCosts = maxDist;
+      PointVisitingCosts = pointVisitCosts;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new OrienteeringProblemData(this, cloner);
+    }
+
+    public double GetScore(int site) => Scores[site];
+
+    public OrienteeringSolution GetSolution(IntegerVector route, double quality, double score, double travelCosts) {
+      return new OrienteeringSolution(route, this, quality, score, travelCosts);
+    }
+
+    public OPData Export() {
+      var tspExport = RoutingData.Export();
+      return new OPData() {
+        Name = tspExport.Name,
+        Description = tspExport.Description,
+        Coordinates = tspExport.Coordinates,
+        Dimension = tspExport.Dimension,
+        DistanceMeasure = tspExport.DistanceMeasure,
+        Distances = tspExport.Distances,
+        MaximumDistance = MaximumTravelCosts,
+        Scores = Scores.CloneAsArray(),
+        StartingPoint = StartingPoint,
+        TerminalPoint = TerminalPoint,
+        PointVisitingCosts = PointVisitingCosts
+      };
+    }
+
+    private static double[,] defaultCoordinates = new double[21, 2] {
+      {  4.60,  7.10 }, {  5.70, 11.40 }, {  4.40, 12.30 }, {  2.80, 14.30 }, {  3.20, 10.30 },
+      {  3.50,  9.80 }, {  4.40,  8.40 }, {  7.80, 11.00 }, {  8.80,  9.80 }, {  7.70,  8.20 },
+      {  6.30,  7.90 }, {  5.40,  8.20 }, {  5.80,  6.80 }, {  6.70,  5.80 }, { 13.80, 13.10 },
+      { 14.10, 14.20 }, { 11.20, 13.60 }, {  9.70, 16.40 }, {  9.50, 18.80 }, {  4.70, 16.80 },
+      {  5.00,  5.60 }
+    };
+    private static double[] defaultScores = new double[21] { 0, 20, 20, 30, 15, 15, 10, 20, 20, 20, 15, 10, 10, 25, 40, 40, 30, 30, 50, 30, 0 };
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering/3.3/OrienteeringSolution.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering/3.3/OrienteeringSolution.cs	(revision 17524)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering/3.3/OrienteeringSolution.cs	(revision 17525)
@@ -20,83 +20,42 @@
 #endregion
 
-using System;
+using System.ComponentModel;
 using System.Drawing;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
 using HeuristicLab.Encodings.IntegerVectorEncoding;
-using HEAL.Attic;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Problems.TravelingSalesman;
 
 namespace HeuristicLab.Problems.Orienteering {
   [Item("OrienteeringSolution", "Represents a Orienteering solution which can be visualized in the GUI.")]
   [StorableType("BC58ED08-B9A7-40F3-B8E0-A6B33AA993F4")]
-  public sealed class OrienteeringSolution : Item {
+  public sealed class OrienteeringSolution : Item, ITSPSolution {
     public static new Image StaticItemImage {
       get { return HeuristicLab.Common.Resources.VSImageLibrary.Image; }
     }
 
-    [Storable]
-    private IntegerVector integerVector;
-    public IntegerVector IntegerVector {
-      get { return integerVector; }
+    [Storable] private Permutation routeAsPermutation;
+    [Storable] private IntegerVector route;
+    public IntegerVector Route {
+      get { return route; }
       set {
-        if (integerVector != value) {
-          if (integerVector != null) DeregisterIntegerVectorEvents();
-          integerVector = value;
-          if (integerVector != null) RegisterIntegerVectorEvents();
-          OnIntegerVectorChanged();
-        }
+        if (route == value) return;
+        route = value;
+        routeAsPermutation = new Permutation(PermutationTypes.RelativeDirected, value);
+        OnPropertyChanged(nameof(Route));
+        OnPropertyChanged(nameof(ITSPSolution.Tour));
       }
     }
-    [Storable]
-    private DoubleMatrix coordinates;
-    public DoubleMatrix Coordinates {
-      get { return coordinates; }
+    [Storable] private IOrienteeringProblemData opData;
+    public IOrienteeringProblemData OPData {
+      get { return opData; }
       set {
-        if (coordinates != value) {
-          if (coordinates != null) DeregisterCoordinatesEvents();
-          coordinates = value;
-          if (coordinates != null) RegisterCoordinatesEvents();
-          OnCoordinatesChanged();
-        }
-      }
-    }
-    [Storable]
-    private IntValue startingPoint;
-    public IntValue StartingPoint {
-      get { return startingPoint; }
-      set {
-        if (startingPoint != value) {
-          if (startingPoint != null) DeregisterStartingPointEvents();
-          startingPoint = value;
-          if (startingPoint != null) RegisterStartingPointEvents();
-          OnStartingPointChanged();
-        }
-      }
-    }
-    [Storable]
-    private IntValue terminalPoint;
-    public IntValue TerminalPoint {
-      get { return terminalPoint; }
-      set {
-        if (terminalPoint != value) {
-          if (terminalPoint != null) DeregisterTerminalPointEvents();
-          terminalPoint = value;
-          if (terminalPoint != null) RegisterTerminalPointEvents();
-          OnTerminalPointChanged();
-        }
-      }
-    }
-    [Storable]
-    private DoubleArray scores;
-    public DoubleArray Scores {
-      get { return scores; }
-      set {
-        if (scores != value) {
-          if (scores != null) DeregisterScoresEvents();
-          scores = value;
-          if (scores != null) RegisterScoresEvents();
-          OnScoresChanged();
-        }
+        if (opData == value) return;
+        opData = value;
+        OnPropertyChanged(nameof(OPData));
+        OnPropertyChanged(nameof(ITSPSolution.TSPData));
       }
     }
@@ -106,38 +65,34 @@
       get { return quality; }
       set {
-        if (quality != value) {
-          if (quality != null) DeregisterQualityEvents();
-          quality = value;
-          if (quality != null) RegisterQualityEvents();
-          OnQualityChanged();
-        }
+        if (quality == value) return;
+        quality = value;
+        OnPropertyChanged(nameof(Quality));
       }
     }
     [Storable]
-    private DoubleValue penalty;
-    public DoubleValue Penalty {
-      get { return penalty; }
+    private DoubleValue score;
+    public DoubleValue Score {
+      get { return score; }
       set {
-        if (penalty != value) {
-          if (penalty != null) DeregisterPenaltyEvents();
-          penalty = value;
-          if (penalty != null) RegisterPenaltyEvents();
-          OnPenaltyChanged();
-        }
+        if (score == value) return;
+        score = value;
+        OnPropertyChanged(nameof(Score));
       }
     }
     [Storable]
-    private DoubleValue distance;
-    public DoubleValue Distance {
-      get { return distance; }
+    private DoubleValue travelCosts;
+    public DoubleValue TravelCosts {
+      get { return travelCosts; }
       set {
-        if (distance != value) {
-          if (distance != null) DeregisterDistanceEvents();
-          distance = value;
-          if (distance != null) RegisterDistanceEvents();
-          OnDistanceChanged();
-        }
+        if (travelCosts == value) return;
+        travelCosts = value;
+        OnPropertyChanged(nameof(TravelCosts));
+        OnPropertyChanged(nameof(ITSPSolution.TourLength));
       }
     }
+
+    ITSPData ITSPSolution.TSPData => OPData.RoutingData;
+    Permutation ITSPSolution.Tour => routeAsPermutation;
+    DoubleValue ITSPSolution.TourLength => TravelCosts;
 
     [StorableConstructor]
@@ -145,22 +100,18 @@
     private OrienteeringSolution(OrienteeringSolution original, Cloner cloner)
       : base(original, cloner) {
-      this.integerVector = cloner.Clone(original.integerVector);
-      this.coordinates = cloner.Clone(original.coordinates);
+      this.route = cloner.Clone(original.route);
+      this.opData = cloner.Clone(original.opData);
       this.quality = cloner.Clone(original.quality);
-      this.penalty = cloner.Clone(original.penalty);
-      Initialize();
+      this.score = cloner.Clone(original.score);
     }
-    public OrienteeringSolution(IntegerVector integerVector, DoubleMatrix coordinates, IntValue startingPoint, IntValue terminalPoint,
-      DoubleArray scores, DoubleValue quality = null, DoubleValue penalty = null, DoubleValue distance = null)
+    public OrienteeringSolution(IntegerVector route, IOrienteeringProblemData opData, double quality, double score, double travelCosts)
+      : this(route, opData, new DoubleValue(quality), new DoubleValue(score), new DoubleValue(travelCosts)) { }
+    public OrienteeringSolution(IntegerVector route, IOrienteeringProblemData opData, DoubleValue quality = null, DoubleValue score = null, DoubleValue distance = null)
       : base() {
-      this.integerVector = integerVector;
-      this.coordinates = coordinates;
-      this.startingPoint = startingPoint;
-      this.terminalPoint = terminalPoint;
-      this.scores = scores;
+      this.route = route;
+      this.opData = opData;
       this.quality = quality;
-      this.penalty = penalty;
-      this.distance = distance;
-      Initialize();
+      this.score = score;
+      this.travelCosts = distance;
     }
 
@@ -169,166 +120,8 @@
     }
 
-    [StorableHook(HookType.AfterDeserialization)]
-    private void AfterDeserialization() {
-      Initialize();
+    public event PropertyChangedEventHandler PropertyChanged;
+    private void OnPropertyChanged(string property) {
+      PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(property));
     }
-
-    private void Initialize() {
-      if (integerVector != null) RegisterIntegerVectorEvents();
-      if (coordinates != null) RegisterCoordinatesEvents();
-      if (startingPoint != null) RegisterStartingPointEvents();
-      if (terminalPoint != null) RegisterTerminalPointEvents();
-      if (scores != null) RegisterScoresEvents();
-      if (quality != null) RegisterQualityEvents();
-      if (penalty != null) RegisterPenaltyEvents();
-      if (distance != null) RegisterDistanceEvents();
-    }
-
-    #region Events
-    public event EventHandler IntegerVectorChanged;
-    private void OnIntegerVectorChanged() {
-      var changed = IntegerVectorChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-
-    public event EventHandler CoordinatesChanged;
-    private void OnCoordinatesChanged() {
-      var changed = CoordinatesChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-
-    public event EventHandler StartingPointChanged;
-    private void OnStartingPointChanged() {
-      var changed = StartingPointChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-
-    public event EventHandler TerminalPointChanged;
-    private void OnTerminalPointChanged() {
-      var changed = TerminalPointChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-
-    public event EventHandler ScoresChanged;
-    private void OnScoresChanged() {
-      var changed = ScoresChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-
-    public event EventHandler QualityChanged;
-    private void OnQualityChanged() {
-      var changed = QualityChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-
-    public event EventHandler PenaltyChanged;
-    private void OnPenaltyChanged() {
-      var changed = PenaltyChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-
-    public event EventHandler DistanceChanged;
-    private void OnDistanceChanged() {
-      var changed = DistanceChanged;
-      if (changed != null)
-        changed(this, EventArgs.Empty);
-    }
-
-    private void RegisterIntegerVectorEvents() {
-      IntegerVector.ItemChanged += new EventHandler<EventArgs<int>>(IntegerVector_ItemChanged);
-      IntegerVector.Reset += new EventHandler(IntegerVector_Reset);
-    }
-    private void DeregisterIntegerVectorEvents() {
-      IntegerVector.ItemChanged -= new EventHandler<EventArgs<int>>(IntegerVector_ItemChanged);
-      IntegerVector.Reset -= new EventHandler(IntegerVector_Reset);
-    }
-    private void RegisterCoordinatesEvents() {
-      Coordinates.ItemChanged += new EventHandler<EventArgs<int, int>>(Coordinates_ItemChanged);
-      Coordinates.Reset += new EventHandler(Coordinates_Reset);
-    }
-    private void DeregisterCoordinatesEvents() {
-      Coordinates.ItemChanged -= new EventHandler<EventArgs<int, int>>(Coordinates_ItemChanged);
-      Coordinates.Reset -= new EventHandler(Coordinates_Reset);
-    }
-    private void RegisterStartingPointEvents() {
-      StartingPoint.ValueChanged += new EventHandler(StartingPoint_ValueChanged);
-    }
-    private void DeregisterStartingPointEvents() {
-      StartingPoint.ValueChanged -= new EventHandler(StartingPoint_ValueChanged);
-    }
-    private void RegisterTerminalPointEvents() {
-      TerminalPoint.ValueChanged += new EventHandler(TerminalPoint_ValueChanged);
-    }
-    private void DeregisterTerminalPointEvents() {
-      TerminalPoint.ValueChanged -= new EventHandler(TerminalPoint_ValueChanged);
-    }
-    private void RegisterScoresEvents() {
-      Scores.ItemChanged += new EventHandler<EventArgs<int>>(Scores_ItemChanged);
-      Scores.Reset += new EventHandler(Scores_Reset);
-    }
-    private void DeregisterScoresEvents() {
-      Scores.ItemChanged -= new EventHandler<EventArgs<int>>(Scores_ItemChanged);
-      Scores.Reset -= new EventHandler(Scores_Reset);
-    }
-    private void RegisterQualityEvents() {
-      Quality.ValueChanged += new EventHandler(Quality_ValueChanged);
-    }
-    private void DeregisterQualityEvents() {
-      Quality.ValueChanged -= new EventHandler(Quality_ValueChanged);
-    }
-    private void RegisterPenaltyEvents() {
-      Penalty.ValueChanged += new EventHandler(Penalty_ValueChanged);
-    }
-    private void DeregisterPenaltyEvents() {
-      Penalty.ValueChanged -= new EventHandler(Penalty_ValueChanged);
-    }
-    private void RegisterDistanceEvents() {
-      Distance.ValueChanged += new EventHandler(Distance_ValueChanged);
-    }
-    private void DeregisterDistanceEvents() {
-      Distance.ValueChanged -= new EventHandler(Distance_ValueChanged);
-    }
-
-    private void IntegerVector_ItemChanged(object sender, EventArgs<int> e) {
-      OnIntegerVectorChanged();
-    }
-    private void IntegerVector_Reset(object sender, EventArgs e) {
-      OnIntegerVectorChanged();
-    }
-    private void Coordinates_ItemChanged(object sender, EventArgs<int, int> e) {
-      OnCoordinatesChanged();
-    }
-    private void Coordinates_Reset(object sender, EventArgs e) {
-      OnCoordinatesChanged();
-    }
-    private void StartingPoint_ValueChanged(object sender, EventArgs e) {
-      OnStartingPointChanged();
-    }
-    private void TerminalPoint_ValueChanged(object sender, EventArgs e) {
-      OnTerminalPointChanged();
-    }
-    private void Scores_ItemChanged(object sender, EventArgs<int> e) {
-      OnCoordinatesChanged();
-    }
-    private void Scores_Reset(object sender, EventArgs e) {
-      OnCoordinatesChanged();
-    }
-    private void Quality_ValueChanged(object sender, EventArgs e) {
-      OnQualityChanged();
-    }
-    private void Penalty_ValueChanged(object sender, EventArgs e) {
-      OnPenaltyChanged();
-    }
-    private void Distance_ValueChanged(object sender, EventArgs e) {
-      OnDistanceChanged();
-    }
-    #endregion
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs	(revision 17524)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.Orienteering/3.3/Shakers/OrienteeringShakingOperator.cs	(revision 17525)
@@ -22,4 +22,5 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -29,5 +30,4 @@
 using HeuristicLab.Optimization;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.Orienteering {
@@ -64,21 +64,6 @@
       get { return (ILookupParameter<IntegerVector>)Parameters["IntegerVector"]; }
     }
-    public ILookupParameter<DoubleValue> MaximumDistanceParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["MaximumDistance"]; }
-    }
-    public ILookupParameter<IntValue> StartingPointParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["StartingPoint"]; }
-    }
-    public ILookupParameter<IntValue> TerminalPointParameter {
-      get { return (ILookupParameter<IntValue>)Parameters["TerminalPoint"]; }
-    }
-    public ILookupParameter<DistanceMatrix> DistanceMatrixParameter {
-      get { return (ILookupParameter<DistanceMatrix>)Parameters["DistanceMatrix"]; }
-    }
-    public ILookupParameter<DoubleArray> ScoresParameter {
-      get { return (ILookupParameter<DoubleArray>)Parameters["Scores"]; }
-    }
-    public ILookupParameter<DoubleValue> PointVisitingCostsParameter {
-      get { return (ILookupParameter<DoubleValue>)Parameters["PointVisitingCosts"]; }
+    public ILookupParameter<IOrienteeringProblemData> OrienteeringProblemDataParameter {
+      get { return (ILookupParameter<IOrienteeringProblemData>)Parameters["OrienteeringProblemData"]; }
     }
 
@@ -99,10 +84,5 @@
 
       Parameters.Add(new LookupParameter<IntegerVector>("IntegerVector", "The Orienteering Solution given in path representation."));
-      Parameters.Add(new LookupParameter<DoubleValue>("MaximumDistance", "The maximum distance constraint for a Orienteering solution."));
-      Parameters.Add(new LookupParameter<IntValue>("StartingPoint", "Index of the starting point."));
-      Parameters.Add(new LookupParameter<IntValue>("TerminalPoint", "Index of the ending point."));
-      Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix", "The matrix which contains the distances between the points."));
-      Parameters.Add(new LookupParameter<DoubleArray>("Scores", "The scores of the points."));
-      Parameters.Add(new LookupParameter<DoubleValue>("PointVisitingCosts", "The costs for visiting a point."));
+      Parameters.Add(new LookupParameter<IOrienteeringProblemData>("OrienteeringProblemData", "The main data that comprises the orienteering problem."));
 
       Parameters.Add(new LookupParameter<IRandom>("Random", "The random number generator that will be used."));
@@ -115,11 +95,6 @@
     public override IOperation Apply() {
       var initialTour = IntegerVectorParameter.ActualValue;
-      var distances = DistanceMatrixParameter.ActualValue;
-      var scores = ScoresParameter.ActualValue;
-      var startingPoint = StartingPointParameter.ActualValue.Value;
-      var terminalPoint = TerminalPointParameter.ActualValue.Value;
-      var pointVisitingCosts = PointVisitingCostsParameter.ActualValue.Value;
-      double maxDistance = MaximumDistanceParameter.ActualValue.Value;
-      int numPoints = scores.Length;
+      var data = OrienteeringProblemDataParameter.ActualValue;
+      int numPoints = data.RoutingData.Cities;
 
       if (NeighborhoodCountParameter.ActualValue == null)
@@ -142,11 +117,11 @@
           from point in Enumerable.Range(0, numPoints)
           // Calculate the distance when going from the starting point to this point and then to the end point
-          let distance = distances[startingPoint, point] + distances[point, terminalPoint] + pointVisitingCosts
+          let distance = data.RoutingData.GetDistance(data.StartingPoint, point) + data.RoutingData.GetDistance(point, data.TerminalPoint) + data.PointVisitingCosts
           // If this distance is feasible and the point is neither starting nor ending point, check the point
-          where distance < maxDistance && point != startingPoint && point != terminalPoint
+          where distance < data.MaximumTravelCosts && point != data.StartingPoint && point != data.TerminalPoint
           // The point was not yet visited, so add it to the candidate list
           where !initialTour.Contains(point)
           // Calculate the utility of the point at this position
-          let utility = scores[point]
+          let utility = data.GetScore(point)
           orderby utility
           select point
@@ -154,5 +129,5 @@
 
         // Initialize the new tour
-        var actualTour = new List<int> { startingPoint };
+        var actualTour = new List<int> { data.StartingPoint };
 
         // Perform the insertions according to the utility sorting
@@ -160,5 +135,5 @@
 
         // Bring the tour back to be feasible 
-        CleanupTour(actualTour, distances, maxDistance, pointVisitingCosts);
+        CleanupTour(actualTour, data);
 
         // Set new Tour
@@ -213,20 +188,20 @@
     }
 
-    private void CleanupTour(List<int> actualTour, DistanceMatrix distances, double maxDistance, double pointVisitingCosts) {
+    private void CleanupTour(List<int> actualTour, IOrienteeringProblemData data) {
       // Sort the points on the tour according to their costs savings when removed
       var distanceSavings = (
         from removePosition in Enumerable.Range(1, actualTour.Count - 2)
-        let saving = distances.CalculateRemovementSaving(actualTour, removePosition, pointVisitingCosts)
+        let saving = OrienteeringProblem.CalculateRemovementSaving(data, actualTour, removePosition)
         orderby saving descending
         select new SavingInfo { Index = removePosition, Saving = saving }
       ).ToList();
 
-      double tourLength = distances.CalculateTourLength(actualTour, pointVisitingCosts);
+      double tourLength = OrienteeringProblem.CalculateTravelCosts(data, actualTour);
 
       // As long as the created path is infeasible, remove elements
-      while (tourLength > maxDistance) {
+      while (tourLength > data.MaximumTravelCosts) {
         // Remove the point that frees the largest distance
         // Note, distance savings are not updated after removal
-        tourLength -= distances.CalculateRemovementSaving(actualTour, distanceSavings[0].Index, pointVisitingCosts);
+        tourLength -= OrienteeringProblem.CalculateRemovementSaving(data, actualTour, distanceSavings[0].Index);
         actualTour.RemoveAt(distanceSavings[0].Index);
 
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/ProbabilisticTSPData.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/ProbabilisticTSPData.cs	(revision 17524)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.PTSP/3.3/ProbabilisticTSPData.cs	(revision 17525)
@@ -58,9 +58,5 @@
     }
     public ProbabilisticTSPData(ITSPData tspData, double[] probabilities)
-      : base(tspData.Name, tspData.Description) {
-      if (tspData.Cities != probabilities.Length) throw new ArgumentException("Unequal number of cities and probabilities.");
-      TSPData = tspData;
-      Probabilities = new PercentArray(probabilities, @readonly: true);
-    }
+      : this(tspData, new PercentArray(probabilities, @readonly: true)) { }
     public ProbabilisticTSPData(ITSPData tspData, PercentArray probabilities)
       : base(tspData.Name, tspData.Description) {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSP.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSP.cs	(revision 17524)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSP.cs	(revision 17525)
@@ -47,5 +47,6 @@
     [Storable] public IValueParameter<ITSPData> TSPDataParameter { get; private set; }
     [Storable] public IValueParameter<ITSPSolution> BestKnownSolutionParameter { get; private set; }
-    [Storable] public IResultParameter<ITSPSolution> BestTSPSolutionParameter { get; private set; }
+    [Storable] protected IResultParameter<ITSPSolution> BestTSPSolutionParameter { get; private set; }
+    public IResultDefinition<ITSPSolution> BestTSPSolution => BestTSPSolutionParameter;
 
     public ITSPData TSPData {
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSPData.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSPData.cs	(revision 17524)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSPData.cs	(revision 17525)
@@ -21,4 +21,5 @@
 
 using System;
+using System.Collections.Generic;
 using HEAL.Attic;
 using HeuristicLab.Common;
@@ -34,4 +35,5 @@
 
     double GetDistance(int fromCity, int toCity);
+    double GetPathDistance(IEnumerable<int> path, bool closed = true);
     ITSPSolution GetSolution(Permutation tspTour, double tourLength);
     TSPData Export();
@@ -85,5 +87,18 @@
 
     public double GetDistance(int fromCity, int toCity) => Matrix[fromCity, toCity];
-
+    public double GetPathDistance(IEnumerable<int> path, bool closed = true) {
+      var iter = path.GetEnumerator();
+      if (!iter.MoveNext()) return 0;
+      var start = iter.Current;
+      var prev = start;
+      var distance = 0.0;
+      while (iter.MoveNext()) {
+        var cur = iter.Current;
+        distance += Matrix[prev, cur];
+        prev = cur;
+      }
+      if (closed) distance += Matrix[prev, start];
+      return distance;
+    }
     public TSPData Export() {
       return new TSPData() {
@@ -133,4 +148,18 @@
 
     public abstract double GetDistance(double fromX, double fromY, double toX, double toY);
+    public double GetPathDistance(IEnumerable<int> path, bool closed = true) {
+      var iter = path.GetEnumerator();
+      if (!iter.MoveNext()) return 0;
+      var start = iter.Current;
+      var prev = start;
+      var distance = 0.0;
+      while (iter.MoveNext()) {
+        var cur = iter.Current;
+        distance += GetDistance(prev, cur);
+        prev = cur;
+      }
+      if (closed) distance += GetDistance(prev, start);
+      return distance;
+    }
 
     public virtual ITSPSolution GetSolution(Permutation tour, double tourLength) {
